Compare commits

...

16 Commits

Author SHA1 Message Date
e74ada7369 externalisation gestion listes paquets installés 2021-07-05 14:18:07 +02:00
e8f10d4e42 mise au point fonction commandIsWorking 2021-07-02 11:54:44 +02:00
83aa4dc018 add cleanUpPkgList 2021-06-14 22:16:56 +02:00
d70db48add ajout fonctiondirMustContains 2021-06-14 22:14:16 +02:00
203d20bb11 user variable deleted at each iteration 2021-06-02 17:14:54 +02:00
4f2d8f9bac modif function serviceIsEnabled 2021-06-02 17:12:27 +02:00
451752901c localize serviceIsEnabled, remove serviceIsActive 2021-03-23 22:03:55 +01:00
347a9362ad ajout possibilité tester 1 seule machine 2021-03-22 15:36:50 +01:00
1a311bc1cf correction fonction numlines 2021-03-22 15:33:10 +01:00
9538b1f0d6 rajout numline 2021-03-19 12:01:00 +01:00
60f8fb1782 fix some typo
localize isinstalled function
2021-02-23 12:18:00 +01:00
fb03f6318c Merge branch 'master' of ssh://infra.opendoor.fr:2222/srv/git/repos/tom/eval_functions 2021-02-23 12:11:50 +01:00
3bc7f94ac2 functions
some moar local functions
2021-02-23 12:11:37 +01:00
5b642806b1 amelioration hostname et csv 2021-02-23 10:58:09 +01:00
9921222131 functions: renommage fonction
localeval: more robust hostname handling
2021-02-22 11:02:14 +01:00
bb26868607 check mtime of bash history file 2021-02-08 18:29:47 +01:00
3 changed files with 129 additions and 39 deletions

View File

@@ -4,6 +4,16 @@ function e {
echo -ne "${1};"
}
# file age
# return 0 if given file mtime is older than given age (in day)
# arg1: file
# arg2: age to compare
function _fileOlderThan {
if [ ! -f $1 ] ; then echo -ne "0;" ; return 0 ; fi
test $(find test -mtime +$2)
return $?
}
# file mtime
# arg1: file
function fileMTime {
@@ -11,6 +21,14 @@ function fileMTime {
stat --printf "%y;" $1
}
# file numline
# arg1: file
function fileNumLines {
if [ ! -f $1 ] ; then echo -ne "0;" ; return 0 ; fi
n=$(wc -l $1 | awk '{print $1}')
echo -ne $n;
}
#ok if given program returns given code
# arg1: program to run
@@ -33,7 +51,7 @@ function fileBiggerThan {
#Ok if file exists
# arg1: file to check
function fileMustExist {
function fileMustExists {
if [ -f ${1} ] ; then echo -ne "1;"
else echo -ne "0;"
fi
@@ -41,7 +59,7 @@ fi
#Ok if file DOESNOT exists
# arg1: file to check
function fileMustNOTExist {
function fileMustNOTExists {
if [ -f ${1} ] ; then echo -ne "0;"
else echo -ne "1;"
fi
@@ -49,23 +67,38 @@ fi
#Ok if dir exists
# arg1: dir to check
function dirMustExist {
if [ -d ${1} ] ; then echo -ne "1;"
else echo -ne "0;"
function dirMustExists {
if [ -d ${1} ] ; then e 1
else e 0
fi
}
# Ok if given dir DOESNOT exists
# arg1: dir
function dirMustNOTExist {
function dirMustNOTExists {
if [ -d ${1} ] ; then echo -ne "0;"
else echo -ne "1;"
fi
}
# Ok if some files of given dir contains at least one occurence of pattern
# arg1: dir
# arg2: pattern
function dirMustContains {
dir=$1
shift
string=$@
if [ ! -d $dir ] ; then echo -ne "0;" ; return 0 ;fi
if ( grep -ri -qE "${string}" $dir ) ;
then echo -ne "1;"
else
echo -ne "0;"
fi
}
# Ok if file contains at least one occurence of pattern
# arg1: file
# arg2: pattern
function fileMustContain {
function fileMustContains {
file=$1
shift
string=$@
@@ -84,16 +117,18 @@ function fileCountPattern {
file=$1
shift
string=$@
if [ ! -f $file ] ; then echo -ne "0;" ; return 0 ;fi
if [ ! -f $file ] ; then e 0 ; return 0 ;fi
local size=$(stat --printf '%s' $file)
if [ $size -eq 0 ] ; then e 0 ; return 0 ; fi
num=$(grep -ciE "${string}" $file )
echo -ne "$num;"
e "$num"
}
# Ok if file contains N pattern
# arg1: file
# arg2: num of expected item
# arg3: pattern
function fileMustContainNItem {
function fileMustContainsNItem {
file=$1
n=$2
shift
@@ -110,7 +145,7 @@ function fileMustContainNItem {
# Ok if file DOESNOT contain pattern
# Arg1: file
# ArgN: pattern
function fileMustNOTContain {
function fileMustNOTContains {
file=$1
shift
string=$@
@@ -140,20 +175,41 @@ function addHeader {
echo -ne "${user}$(hostname -s);"
}
# get file md5
# arg1: file to checksum
function md5 {
test -f "$1" && local am=$(md5sum "$1" | awk '{print $1}')
echo -ne "${am};"
}
# cleanUppkgList
# arg1: rootfs
function cleanUppkgList {
test -d ${1} || return 0
test -f ${1}/tmp/pkg.list && rm -f ${1}/tmp/pkg.list
}
# init pkg list
# arg1: rootfs
function initPkgList {
root="$1"
test -f "${1}/tmp/pkg.list" || chroot "$1" sh -c "rpm -qa > /tmp/pkg.list"
}
# Ok if given package is installed
# arg1: pkg to check
# arg1: rootfs
# arg2: pkg to check
# WARNING: package list might not be up to date
function pkgInstalled {
pkglist=/tmp/pkg.list
test -f $pkglist || rpm -qa > $pkglist
if ( grep -qi $1 $pkglist ) ; then echo -ne "1;" ; else echo -ne "0;" ; fi
if (grep -qi "$2" "${1}/tmp/pkg.list" ) ; then e 1 ; else e 0 ; fi
}
# Ok if given package is NOT installed
# arg1: pkg to check
# WARNING: package list might not be up to date
function pkgNotInstalled {
pkglist=/tmp/pkg.list
test -f $pkglist || rpm -qa > $pkglist
if ( grep -qiE $1 $pkglist ) ; then echo -ne "0;" ; else echo -ne "1;" ; fi
if (grep -qi "$2" "${1}/tmp/pkg.list" ) ; then e 0 ; else e 1 ; fi
echo -ne "${?};"
}
# ok if given process is running
@@ -163,10 +219,16 @@ function processIsRunning {
}
#Ok if given command returns 0
# arg1: command to be run
# arg1: chroot dir
# arg2: command to be run
function commandIsWorking {
command=$1
if ( $command &> /dev/null ) ; then echo -ne "1;" ; else echo -ne "0;" ; fi
chroot=$1
shift
command="$@"
chroot ${chroot} bash -c "$command" &> /dev/null
ret=$?
if [ $ret -eq 0 ] ; then e 1 ; else e 0 ; fi
}
# ok if given pattern is detected on command's stdout or stderr
@@ -182,15 +244,10 @@ function commandStdoutPattern {
# ok if given service is enabled
# arg1: service
function serviceIsEnabled {
service=$1
if ( systemctl is-enabled $1 &> /dev/null ) ; then echo -ne "1;" ; else echo -ne "0;" ; fi
}
# ok if given service is active
# arg1: service
function serviceIsActive {
service=$1
if ( systemctl is-active $1 &> /dev/null ) ; then echo -ne "1;" ; else echo -ne "0;" ; fi
local root=$1
local service=${2}.service
c=$(ls -l ${root}/etc/systemd/system/multi-user.target.wants/ | grep -i ${service} | wc -l)
if [ $c -gt 0 ] ; then e 1 ; else e 0 ; fi
}
# ok if output of given url contains given stuff

23
initPkg.sh Normal file
View File

@@ -0,0 +1,23 @@
#! /bin/bash
set -e
IFS=$'\n\t'
source functions.sh
echo -ne "host;name;root history;bash history;<+CHANGEME+>\n"
if [ $# -ge 1 ] ; then
hostlist=/srv/lxc/epsi/$1
else
hostlist=/srv/lxc/epsi/*
fi
for host in $hostlist ; do
root=${host}/rootfs
host=$(basename $host)
hostname=$(grep HOSTNAME ${root}/etc/sysconfig/network 2>/dev/null| cut -f2 -d=)
test -z "${hostname}" && hostname=$(cat ${root}/etc/hostname)
test -f ${root}/etc/motd && user="$(cat ${root}/etc/motd | xargs)"
echo -ne "${hostname};${user};"
unset user
initPkgList ${root}
echo
done

View File

@@ -1,14 +1,24 @@
#! /bin/bash
set -e
IFS=$'\n\t'
source functions.sh
# check that alias has been tried
echo -ne "host\tname\t<+CHANGEME+>\n"
for host in /srv/lxc/epsi/b1/* ; do
echo -ne "host;name;root history;bash history;<+CHANGEME+>\n"
if [ $# -ge 1 ] ; then
hostlist=/srv/lxc/epsi/b2/$1
else
hostlist=/srv/lxc/epsi/b2/*
fi
for host in $hostlist ; do
root=${host}/rootfs
host=$(basename $host)
hostname=$(grep HOSTNAME ${root}/etc/sysconfig/network | cut -f2 -d=)
test -f ${root}/etc/motd && user="$(cat ${root}/etc/motd | sed 's/\n//')\t"
echo -ne "${hostname}\t${user}"
<+CHANGEME+>
echo
hostname=$(grep HOSTNAME ${root}/etc/sysconfig/network 2>/dev/null| cut -f2 -d=)
test -z "${hostname}" && hostname=$(cat ${root}/etc/hostname)
test -f ${root}/etc/motd && user="$(cat ${root}/etc/motd | xargs)"
echo -ne "${hostname};${user};"
fileMTime ${root}/root/.bash_history
fileMTime ${root}/home/formation/.bash_history
unset user
echo
done